/*
    This program demonstrates the use of command line parameters.

    Try it with 0, 1, 2, 3, and 4 parameters on the command line, e.g.:

                    DEMO_ARG these are my params: /V /T /X

    See what happens when you rename the program to DX for example.


    Compiler:       Microsoft C Version 5.0+
    Switches:       none


    Submitted by    Gerry J. Danen
                    106 Abbotsfield Road
                    Edmonton, Alberta CANADA
                    T5W 4S9
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <malloc.h>


#define pgVERS_ "V2.00"
#define pgTITL_ "Demo the Use of Command Line Parameters"
#define pgCOPR_ "1988-"


void    main( int argc, char *argv[] )
{
    char *pgm, arg1[80], arg2[80], arg3[80] ;
    int  i ;

    printf( "\nThis program demonstrates the use of command line parameters.\n\n" );

    strcpy( arg1, "" );                         // set to null strings, in case
    strcpy( arg2, "" );                         // no corresponding command line
    strcpy( arg3, "" );                         //  are given.

    for ( i=0 ; i<argc ; i++, argv++ )          // loop while we have parameters
    {
        printf( "Arg# %2d, length = %2d, contents: \"%s\"\n", i, strlen(*argv), *argv );
        if ( i == 0 )
        {
            if ( (pgm = calloc(1, strlen(*argv))) == NULL )
            {
                printf( "Sorry, can't allocate memory\a\n" );
                exit( 1 );                      // exit with ERRORLEVEL 1
            }
            else
                strcpy( pgm, *argv );           // parameter 0 = program name
        }
        if ( i == 1 )
            strcpy( arg1, *argv );
        if ( i == 2 )
            strcpy( arg2, *argv );
        if ( i == 3 )
            strcpy( arg3, *argv );
    }

    printf( "\nMy full name = %s\n\n", pgm );   // includes path name

    if ( argc < 2 )
    {
        printf( "You did not specify any parameters!\n\n" );
        exit( 1 );                              // set ERRORLEVEL to 1 and exit
    }

    if ( argc > 1 )
        printf( "Parameter(s): 1=%s\n", arg1 );
    if ( argc > 2 )
        printf( "              2=%s\n", arg2 );
    if ( argc > 3 )
        printf( "              3=%s\n", arg3 );
    if ( argc > 4 )
        printf( "Extra parameter(s) ignored\a\n" );

    printf( "\nParameter count = %d\n\n", argc-1 ); // argc includes param 0

    exit( 0 );                                  // exit with ERRORLEVEL 0
}
