//<t>   Determine if user is member of group

//      Returns errorlevel 1 if user IS a member

#include"gd_tools.h"
#include"gd_nw.h"


#define pgVERS_ "V1.00"
#define pgTITL_ "Check NetWare Group Membership for Logged-In User"
#define pgCOPR_ "1995"


void    main( int argc, char *argv[] )
{
    UCHAR       uName[49], gName[49] ;

    tt_init( SHAREWARE_VERSION, 0, pgVERS_, pgTITL_, pgCOPR_ );

    nw_get_username( uName );

    if ( ! st_len(uName) )                      // not logged in
    {
        logon( 1 );
        printf( "Not logged in!\a\n" );
        exit( 0 );
    }

    if ( argc < 2 )
    {
        logon( 1 );
        printf( "No group specified!\nSpecify a group name to check on the command line.\a\n" );
        exit( 0 );
    }
    ST_CPY( gName, argv[1] );
    strupr( gName );

    if ( nw_is_user_in_group( uName, gName ) )
    {
        printf( "User %s is a member of group %s\n", uName, gName );
        exit( 1 );
    }

    printf( "User %s is not in group %s\a\n", uName, gName );
    exit( 0 );
}
